attribute mediump vec4 a_position;
attribute lowp vec4 a_color;
attribute mediump vec2 a_texCoord;
uniform mediump mat4 u_modelViewProjectionMatrix;
uniform lowp vec4 u_color4;
	
varying lowp vec4 v_color;
varying lowp vec4 vm_color;
uniform highp vec4 uv_tiling_scroll;
// x tiling, y tiling, displacement, void
varying lowp vec2 scrollUV0;

void main() {
	gl_Position = u_modelViewProjectionMatrix * a_position;
	v_color = a_color;
	vm_color = a_color * u_color4;

	scrollUV0 = a_texCoord.xy*uv_tiling_scroll.xy + (vm_color.rg*2.0-1.0) * uv_tiling_scroll.xy * uv_tiling_scroll.z;
}